; CBLAYR.LSP  Change entity color to BYLAYER.
;
;     Copyright (C) 1992 by Autodesk, Inc.
;
;     Permission to use, copy, modify, and distribute this software 
;     for any purpose and without fee is hereby granted, provided 
;     that the above copyright notice appears in all copies and that 
;     both that copyright notice and this permission notice appear in 
;     all supporting documentation.
;
;     THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
;     WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;     PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;     ****************************************************************
;
; This program sorts entities by their color, and places all entities with
; the same color on a layer whose name is the color number (e.g., entities
; with the color # 3 will be placed on a layer named "3").
;
; The entity color of all entities are changed to "BYLAYER", and the layer
; inherits the color of the entities placed on it.
;
; Essentially, this program was written to eliminate entities with explicit
; color properties, in preperation for exporting via DXF to a post-processor
; that does not honor color-by-entity.   Use at your own risk.

   (defun C:CBYLAYER ( / ss i hi clayer)
      (initget 7)
      (setq maxcolor (getint "\nHchste Farbnummer: "))
      (setq i 0)
      (princ "\nndern der Objektfarbe von by-entity in VONLAYER...")
      (setq hi (getvar "highlight"))
      (setq clayer (getvar "clayer"))
      (setvar "highlight" 0)
      (setvar "cmdecho" 0)
      (command "")
      (setq i 0)
      (repeat maxcolor
         (if (setq ss (ssget "x" (list (cons 62 (setq i (1+ i))))))
           (progn  
             (command "_layer" "_make" (itoa i) "_c"  i "" "")
             (command "_chprop" ss "" "_la" (itoa i) "_c" "_bylayer" "")))
         )
      (setvar "highlight" hi)
      (command "_layer" "se" clayer "")
      (princ)
   )
